/*!
 * © 2021 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */

/* globals Names, ROT, OpeningMove, Continuation */
/* exported Rikishi */
class Rikishi {
	constructor() {
		this._name = Names.getAName();
		this._spd = ROT.RNG.getPercentage();
		this._agl = ROT.RNG.getPercentage();
		this._str = ROT.RNG.getPercentage();
		this._wgt = ROT.RNG.getPercentage();
		this._bal = ROT.RNG.getPercentage();
		this._wins = 0;
		this._losses = 0;
	}
	getSpeed() {
		return this._spd;
	}
	getAgility() {
		return this._agl;
	}
	getStrength() {
		return this._str;
	}
	getWeight() {
		return this._wgt;
	}
	getBalance() {
		return this._bal;
	}
	getOpeningMove() {
		return ROT.RNG.getItem([OpeningMove.Charge,OpeningMove.Attack,OpeningMove.StepAside,OpeningMove.Slap]);
	}
	getContinuation() {
		return ROT.RNG.getItem([Continuation.Lever,Continuation.Lift,Continuation.Push,Continuation.Pull]);
	}
	saves() {
		return (ROT.RNG.getPercentage() < (this._bal+24)/5);
	}
	toString() {
		return this._name;
	}
	getScore() {
		return this._wins+"-"+this._losses;
	}
	addWin() {
		this._wins++;
	}
	addLoss() {
		this._losses++;
	}
	getWins() {
		return this._wins;
	}
	getLosses() {
		return this._losses;
	}
}
